--------------------------------------------------------------------------------------
-- MOD: LoadStatus
-- MOD Author: WLKe
-- MOD date: 15.9.2012
-- Version 0.7.3 - 16.9.2012
-- Thanks edmund (Inspector),rafftnix (RenderVehicleFillStates) for inspiration.
-- Copyright (C) WLKe -- wlke@wlke.net
--------------------------------------------------------------------------------------
print("LoadStatus 0.7.3 by WLKe loaded");
Loadstatus = {};

function Loadstatus:loadMap(name)
Loadstatus.checkCourseplay = true
end;
function Loadstatus:deleteMap()
end;
function Loadstatus:mouseEvent(posX, posY, isDown, isUp, button)
end;

function Loadstatus:loadSteerable(xmlFile)
  -- Try to find the name of the vehicle.
  if self.name == nil then self.name = getXMLString(xmlFile, "vehicle.name.".. g_languageShort); end;
  if self.name == nil then self.name = getXMLString(xmlFile, "vehicle.name"); end;
  if self.name == nil then self.name = getXMLString(xmlFile, "vehicle#type"); end;
  if self.name == nil then
      self.name = "Steerable" 
  end;
end;
function  Loadstatus:loadAttachable(xmlFile)
  if self.name == nil then self.name = getXMLString(xmlFile, "vehicle.name.".. g_languageShort); end;
  if self.name == nil then self.name = getXMLString(xmlFile, "vehicle.name"); end;
  if self.name == nil then self.name = getXMLString(xmlFile, "vehicle#type"); end;
  if self.name == nil then
      self.name = "Attachable"
  end;
end;
Steerable.load  = Utils.appendedFunction(Steerable.load, Loadstatus.loadSteerable);
Attachable.load = Utils.appendedFunction(Attachable.load, Loadstatus.loadAttachable);



function Loadstatus:keyEvent(unicode, sym, modifier, isDown)
	if isDown and sym == Input.KEY_a and bitAND(modifier, Input.MOD_ALT) > 0 then
		if dShow then 
			dShow = false;
		else
			dShow = true;
		end;
	end;
	if isDown and sym == Input.KEY_slash then
		if dShowPercent == true and dShowFill ~= true then 
			dShowFill = true;
			dShowPercent = false;
			return true;
		end;
		if dShowFill == true and dShowPercent == false then
			dShowPercent = true;
			return true;
		end;
		if dShowPercent == true and dShowFill == true then
			dShowFill = false;
			dShowPercent = true;
			return true;
		end;
		if dShowPercent == nil and dShowFill == nil then dShowPercent = true; end;
	end;
end;

function Loadstatus:update(dt)
end;

function Loadstatus:draw()
	if dShow then return true; end;

	if Input.keyPressedState[308] then
		return true;
	else
	------------------------ User Customizable parameters -------------------
		local GrainTankPercentageWarn = 80;  -- warn level for combines		(default 80)
		local fFontSize = 0.015;			-- font size					(default 0.015)
		local LineWrap = .87		-- wrap long line (in % / 100)			(default .87)
		local NameSizeLimit = 15;	-- Vehicle name string lenght limit		(default 15)
		-------------------------------------------------------------------------
		
		local fPosX = 0.014;
		local fPosY = 0.62;
		local fLineDist = fFontSize + 0.0017;
		setTextAlignment(RenderText.ALIGN_LEFT);
		local nLine = 0;
		local hasFillable = false;
		local hasGrainTank = false;
		local hasLowType = false;
		local i18FillType = "";
		local FillPercentage = 0;
		local Printed = false;
		
		for i=1,table.getn(g_currentMission.steerables) do
			local textController = "";
			local GrainTankPercentage = 0;
			local textVehicleFill="";
			local textVehicleName="";
			local textPosX = fPosX;
			Printed = false;
			local vehicle = g_currentMission.steerables[i]; -- steerables
			hasGrainTank = false; hasFillable = false; hasLowType = false;
			setTextBold(false);
			setTextColor(1,1,1,1);
			if vehicle.isControlled then				
				if vehicle.controllerName ~= nil then 
					textController = " (" ..string.sub(Utils.getNoNil(vehicle.controllerName, g_i18n:getText("UNKNOWN")), 0, 15) .. ") "; 
				end;
				if g_currentMission.controlledVehicle == vehicle then
					setTextBold(true);
				end;
			end;
			if vehicle.name ~= nil then
				textVehicleName = vehicle.name;
			end;
			 hasFillable = false;
----------------------------- fillable vehicle				
			if vehicle.fillLevel ~= nil and vehicle.capacity ~= nil and vehicle.currentFillType ~= nil then
				hasFillable = true;
				FillPercentage = vehicle.fillLevel / vehicle.capacity * 100;
				local FillType = "";
				if vehicle.currentFillType ~= Fillable.FILLTYPE_UNKNOWN and vehicle.currentFillType ~=  nil then
					FillType = Fillable.fillTypeIntToName[vehicle.currentFillType].."";
				end;
				i18FillType = "";

					if g_i18n:hasText(FillType) then
						i18FillType = g_i18n:getText(FillType);
						else 
							i18FillType = FillType;
					end;
					if vehicle.isHired  and Printed ~= true then	
						setTextColor(0.72,0.80,0.98,1);	
						renderText(textPosX, fPosY-(nLine*fLineDist), fFontSize, i..") ");
						textPosX=textPosX+getTextWidth(fFontSize,tostring(i..") "));
						renderText(textPosX, fPosY-(nLine*fLineDist), fFontSize,"[H] ");
						textPosX=textPosX+getTextWidth(fFontSize,tostring("[H] "));
						renderText(textPosX, fPosY-(nLine*fLineDist), fFontSize,textController..textVehicleName); -- print controler + vehicle name
						textPosX=textPosX+getTextWidth(fFontSize,tostring(textController..textVehicleName)); -- print controler + vehicle name
						Printed = true;
					else
						if Printed ~= true then
							renderText(textPosX, fPosY-(nLine*fLineDist), fFontSize, i..") "..textController..textVehicleName); -- print controler + vehicle name
							textPosX=textPosX+getTextWidth(fFontSize,tostring(i..") "..textController));
							textPosX=textPosX+getTextWidth(fFontSize,tostring(textVehicleName));
							setTextColor(1,1,1,1);
							Printed = true;
						end;
					end;
					if FillType == "fertilizer" and FillPercentage < 10 then setTextBold(true);setTextColor(1,0,0,1); end;
					renderText(textPosX, fPosY-(nLine*fLineDist), fFontSize,"@");
					textPosX=textPosX+getTextWidth(fFontSize,"@");							
					if FillPercentage > 0 then
						if dShowPercent or not dShowFill then
							renderText(textPosX, fPosY-(nLine*fLineDist), fFontSize,tostring(math.ceil(FillPercentage - 0.5)).."%");
							textPosX=textPosX+getTextWidth(fFontSize,tostring(math.ceil(FillPercentage - 0.5)).."%");
						end;
						if dShowPercent and dShowFill then 
							renderText(textPosX, fPosY-(nLine*fLineDist), fFontSize,"=");
							textPosX=textPosX+getTextWidth(fFontSize,"=");
						end							
						if dShowFill then
							renderText(textPosX, fPosY-(nLine*fLineDist), fFontSize,tostring(math.ceil(vehicle.fillLevel)).."L");
							textPosX=textPosX+getTextWidth(fFontSize,tostring(math.ceil(vehicle.fillLevel)).."L");
						end;							
						renderText(textPosX, fPosY-(nLine*fLineDist),fFontSize," ("..i18FillType..")");
						textPosX=textPosX+getTextWidth(fFontSize,tostring(" ("..i18FillType));
						setTextColor(1,1,1,1);setTextBold(false);
					else
						setTextColor(1,1,1,1);setTextBold(false);
						Printed = true;
						renderText(textPosX, fPosY-(nLine*fLineDist), fFontSize,"(Empty)");
						textPosX=textPosX+getTextWidth(fFontSize,tostring("(Empty)"));
					end;
			else
				if vehicle.isHired and Printed ~= true then	
					setTextColor(0.72,0.80,0.98,1);	
					renderText(textPosX, fPosY-(nLine*fLineDist), fFontSize, i..") ");
					textPosX=textPosX+getTextWidth(fFontSize,tostring(i..") "));
					renderText(textPosX, fPosY-(nLine*fLineDist), fFontSize,"[H] ");
					textPosX=textPosX+getTextWidth(fFontSize,tostring("[H] "));
					renderText(textPosX, fPosY-(nLine*fLineDist), fFontSize,textController..textVehicleName); -- print controler + vehicle name
					textPosX=textPosX+getTextWidth(fFontSize,tostring(textController..textVehicleName)); -- print controler + vehicle name
					Printed = true;
				end;
			end;
--------------------------------------- zobrazenie kombajnu -----------------------------				
			if  vehicle.grainTankFillLevel ~= nil and vehicle.grainTankCapacity ~= nil and vehicle.currentGrainTankFruitType ~= nil then
				hasGrainTank = true;
				GrainTankPercentage = vehicle.grainTankFillLevel / vehicle.grainTankCapacity * 100;
				GrainTankPercentage = math.ceil(GrainTankPercentage - 0.5);
				local FruitType = "";
				if vehicle.currentGrainTankFruitType ~= "unknown" and vehicle.currentGrainTankFruitType ~= nil and vehicle.grainTankFillLevel > 0 then 
					FruitType = FruitUtil.fruitIndexToDesc[vehicle.currentGrainTankFruitType].name;
				else
					FruitType = "unknown";
				end;
					if g_i18n:hasText(FruitType) then
						i18FruitType = g_i18n:getText(FruitType);
						else 
							i18FruitType = FruitType;	-- if not translate version
					end;
					if hasFillable ~= true then
						if vehicle.isHired and Printed ~= true then 	
							setTextColor(0.72,0.80,0.98,1);	
							renderText(textPosX, fPosY-(nLine*fLineDist), fFontSize, i..") ");
							textPosX=textPosX+getTextWidth(fFontSize,tostring(i..") "));
							renderText(textPosX, fPosY-(nLine*fLineDist), fFontSize,"[H] ");
							textPosX=textPosX+getTextWidth(fFontSize,tostring("[H] "));
							renderText(textPosX, fPosY-(nLine*fLineDist), fFontSize,textController..textVehicleName); -- print controler + vehicle name
							textPosX=textPosX+getTextWidth(fFontSize,tostring(textController..textVehicleName)); -- print controler + vehicle name
							Printed = true;
						else
							if Printed ~= true then
								renderText(textPosX, fPosY-(nLine*fLineDist), fFontSize, i..") "..textController..textVehicleName); -- print controler + vehicle name
								Printed = true;
								textPosX=textPosX+getTextWidth(fFontSize,tostring(i..") "..textController));
								textPosX=textPosX+getTextWidth(fFontSize,tostring(textVehicleName));
								setTextColor(1,1,1,1);
							end;
						end;
						if hasGrainTank and vehicle.grainTankFillLevel > 0 then setTextBold(true);	setTextColor(0,1,0,1); else	setTextColor(1,1,1,1);end;
						if GrainTankPercentage > GrainTankPercentageWarn then setTextColor(1,0,0,1); end;
						renderText(textPosX, fPosY-(nLine*fLineDist), fFontSize,"@");
						textPosX=textPosX+getTextWidth(fFontSize,"@");
						if vehicle.grainTankFillLevel > 0 then 
							if dShowPercent or not dShowFill then
								renderText(textPosX, fPosY-(nLine*fLineDist), fFontSize,tostring(GrainTankPercentage).."%");
								textPosX=textPosX+getTextWidth(fFontSize,tostring(GrainTankPercentage).."%");
							end;
							if dShowPercent and dShowFill then 
								renderText(textPosX, fPosY-(nLine*fLineDist), fFontSize,"=");
									textPosX=textPosX+getTextWidth(fFontSize,"=");
								end
								if dShowFill then
									renderText(textPosX, fPosY-(nLine*fLineDist), fFontSize,(math.ceil(vehicle.grainTankFillLevel)).."L");
									textPosX=textPosX+getTextWidth(fFontSize,tostring(math.ceil(vehicle.grainTankFillLevel).."L"));
								end;
								renderText(textPosX, fPosY-(nLine*fLineDist), fFontSize,"("..i18FruitType..")");
								textPosX=textPosX+getTextWidth(fFontSize,tostring(" ("..i18FruitType..")"));
							else
								setTextColor(1,1,1,1);setTextBold(false);
								renderText(textPosX, fPosY-(nLine*fLineDist), fFontSize,"(Empty)");
								textPosX=textPosX+getTextWidth(fFontSize,tostring("(Empty)"));
							end;
						end;
			end;
				----------------------------- fillable implements	

			for Index,implement in pairs(vehicle.attachedImplements) do
				if implement ~= nil and implement.object ~= nil then
					if implement.object.fillLevel ~= nil and implement.object.capacity ~= nil and implement.object.currentFillType ~= nil and implement.object.name ~= nil then
						FillPercentage = implement.object.fillLevel / implement.object.capacity * 100;
						local FillType = "";
						if implement.object.currentFillType ~= Fillable.FILLTYPE_UNKNOWN then
							FillType = Fillable.fillTypeIntToName[implement.object.currentFillType];
						else 
							FillType = "unknown";
						end;
						i18FillType = "";
						if g_i18n:hasText(FillType) then
							i18FillType = g_i18n:getText(FillType);
						else 
							i18FillType = FillType;	-- if not translate 
						end;
						if vehicle.isHired and Printed ~= true then	
							setTextColor(0.72,0.80,0.98,1);	
							renderText(textPosX, fPosY-(nLine*fLineDist), fFontSize, i..") ");
							textPosX=textPosX+getTextWidth(fFontSize,tostring(i..") "));
							renderText(textPosX, fPosY-(nLine*fLineDist), fFontSize,"[H] ");
							textPosX=textPosX+getTextWidth(fFontSize,tostring("[H] "));
							renderText(textPosX, fPosY-(nLine*fLineDist), fFontSize,textController..textVehicleName); -- print controler + vehicle name
							textPosX=textPosX+getTextWidth(fFontSize,tostring(textController..textVehicleName)); -- print controler + vehicle name
							Printed = true;
						end;
						if implement.object.fillLevel ~= nil and implement.object.capacity ~= nil then
							if hasFillable == false  and Printed ~= true then 
								if vehicle.isHired and Printed ~= true then	setTextColor(0.72,0.80,0.98,1);	end;
								renderText(textPosX, fPosY-(nLine*fLineDist), fFontSize, i..") "..textController..textVehicleName); -- print controler + vehicle name
								Printed = true;
								textPosX=textPosX+getTextWidth(fFontSize,tostring(i..") "..textController));
								textPosX=textPosX+getTextWidth(fFontSize,tostring(textVehicleName));
								setTextColor(1,1,1,1);
								hasFillable = true;	
							end;
							if textPosX+getTextWidth(fFontSize,tostring("xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx")) > LineWrap then
								nLine = nLine + 1;
								textPosX = fPosX + getTextWidth(fFontSize,tostring(i..") "..textController..textVehicleName));
							end;
							setTextColor(1,1,1,1);
							renderText(textPosX, fPosY-(nLine*fLineDist), fFontSize,"+");
							textPosX=textPosX+getTextWidth(fFontSize,tostring("+"));
							if vehicle.isHired then	setTextColor(0.72,0.80,0.98,1);	end;
							if (FillType == "fertilizer" or FillType == "seeds") and FillPercentage < 10 then setTextBold(true);setTextColor(1,0,0,1); end;
							renderText(textPosX, fPosY-(nLine*fLineDist), fFontSize,string.sub(implement.object.name, 0, NameSizeLimit));
							textPosX=textPosX+getTextWidth(fFontSize,tostring(string.sub(implement.object.name,0, NameSizeLimit)));
							renderText(textPosX, fPosY-(nLine*fLineDist), fFontSize,"@");
							textPosX=textPosX+getTextWidth(fFontSize,"@");							
							if implement.object.fillLevel > 0 then
								if dShowPercent or not dShowFill then
									renderText(textPosX, fPosY-(nLine*fLineDist), fFontSize,tostring(math.ceil(FillPercentage - 0.5)).."%");
									textPosX=textPosX+getTextWidth(fFontSize,tostring(math.ceil(FillPercentage - 0.5)).."%");
								end;
								if dShowPercent and dShowFill then 
									renderText(textPosX, fPosY-(nLine*fLineDist), fFontSize,"=");
									textPosX=textPosX+getTextWidth(fFontSize,"=");
								end							
								if dShowFill then
									renderText(textPosX, fPosY-(nLine*fLineDist), fFontSize,tostring(math.ceil(implement.object.fillLevel)).."L");
									textPosX=textPosX+getTextWidth(fFontSize,tostring(math.ceil(implement.object.fillLevel)).."L");
								end;							
								renderText(textPosX, fPosY-(nLine*fLineDist),fFontSize," ("..i18FillType..")");
								textPosX=textPosX+getTextWidth(fFontSize,tostring(" ("..i18FillType..")"));
								setTextColor(1,1,1,1);setTextBold(false);
							else
								renderText(textPosX, fPosY-(nLine*fLineDist), fFontSize,"(Empty)");
								textPosX=textPosX+getTextWidth(fFontSize,tostring("(Empty)"));
							end;
						end;
					end;
				end;
				for Index2,implement2 in pairs(implement.object.attachedImplements) do
					if implement2.object.fillLevel ~= nil and implement2.object.capacity ~= nil and implement2.object.currentFillType ~= nil and implement2.object.name ~= nil then
						FillPercentage = implement2.object.fillLevel / implement2.object.capacity * 100;
						local FillType = "";
						if implement2.object.currentFillType ~= Fillable.FILLTYPE_UNKNOWN then
							FillType = Fillable.fillTypeIntToName[implement2.object.currentFillType];
						else 
							FillType = "unknown";
						end;
						i18FillType = "";
						if g_i18n:hasText(FillType) then
							i18FillType = g_i18n:getText(FillType);
						else 
							i18FillType = FillType;	-- if not translate version
						end;
						if Printed ~= true then 
							if vehicle.isHired then	setTextColor(0.72,0.80,0.98,1);	end;
							renderText(textPosX, fPosY-(nLine*fLineDist), fFontSize, i..") "..textController..textVehicleName); -- print controler + vehicle name
							Printed = true;
							textPosX=textPosX+getTextWidth(fFontSize,tostring(i..") "..textController));
							textPosX=textPosX+getTextWidth(fFontSize,tostring(textVehicleName));
							setTextColor(1,1,1,1);
							hasFillable = true;	
							Printed = true;
						end;
						if textPosX+getTextWidth(fFontSize,tostring("xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx")) > LineWrap then
							nLine = nLine + 1;
							textPosX = fPosX + getTextWidth(fFontSize,tostring(i..") "..textController..textVehicleName));
						end;
						renderText(textPosX, fPosY-(nLine*fLineDist), fFontSize,"+"..string.sub(implement2.object.name,0, NameSizeLimit));
						textPosX=textPosX+getTextWidth(fFontSize,tostring("+"..string.sub(implement2.object.name,0, NameSizeLimit)));
						if vehicle.isHired then	setTextColor(0.72,0.80,0.98,1);	end;
						if (FillType == "fertilizer" or FillType == "seeds") and FillPercentage < 10 then setTextBold(true);setTextColor(1,0,0,1); end;
						renderText(textPosX, fPosY-(nLine*fLineDist), fFontSize,"@");
						textPosX=textPosX+getTextWidth(fFontSize,"@");							
						if implement2.object.fillLevel > 0 then
							if dShowPercent then
								renderText(textPosX, fPosY-(nLine*fLineDist), fFontSize,tostring(math.ceil(FillPercentage - 0.5)).."%");
								textPosX=textPosX+getTextWidth(fFontSize,tostring(math.ceil(FillPercentage - 0.5)).."%");
							end;
							if dShowPercent and dShowFill then 
								renderText(textPosX, fPosY-(nLine*fLineDist), fFontSize,"=");
								textPosX=textPosX+getTextWidth(fFontSize,"=");
							end							
							if dShowFill then
								renderText(textPosX, fPosY-(nLine*fLineDist), fFontSize,tostring(math.ceil(implement2.object.fillLevel)).."L");
								textPosX=textPosX+getTextWidth(fFontSize,tostring(math.ceil(implement2.object.fillLevel)).."L");
							end;							
							renderText(textPosX, fPosY-(nLine*fLineDist),fFontSize," ("..i18FillType..")");
							textPosX=textPosX+getTextWidth(fFontSize,tostring(" ("..i18FillType..")"));
							setTextColor(1,1,1,1);setTextBold(false);
						else
							renderText(textPosX, fPosY-(nLine*fLineDist), fFontSize," (Empty)");
							textPosX=textPosX+getTextWidth(fFontSize,tostring(" (Empty)"));
						end;
					end;
					for Index3,implement3 in pairs(implement2.object.attachedImplements) do
						if implement3.object.fillLevel ~= nil and implement3.object.capacity ~= nil and implement3.object.currentFillType ~= nil and implement3.object.name ~= nil then
							if implement3.object.fillLevel ~= nil and implement3.object.capacity ~= nil then
								FillPercentage = implement3.object.fillLevel / implement3.object.capacity * 100;
								local FillType = "";
								if implement3.object.currentFillType ~= Fillable.FILLTYPE_UNKNOWN then
									FillType = Fillable.fillTypeIntToName[implement3.object.currentFillType];
								else 
									FillType = "unknown";									
								end;
								i18FillType = "";
								if g_i18n:hasText(FillType) then
									i18FillType = g_i18n:getText(FillType);
								else 
									i18FillType = FillType;	-- if not translate version
								end;
								if Printed ~= true then 
									if vehicle.isHired then	setTextColor(0.72,0.80,0.98,1);	end;
									renderText(textPosX, fPosY-(nLine*fLineDist), fFontSize, i..") "..textController..textVehicleName); -- print controler + vehicle name
									textPosX=textPosX+getTextWidth(fFontSize,tostring(i..") "..textController));
									textPosX=textPosX+getTextWidth(fFontSize,tostring(textVehicleName));
									setTextColor(1,1,1,1);
									hasFillable = true;	
									Printed = true;
								end;
								if textPosX+getTextWidth(fFontSize,tostring("xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx")) > LineWrap then
									nLine = nLine + 1;
									textPosX = fPosX + getTextWidth(fFontSize,tostring(i..") "..textController..textVehicleName));
								end;
								renderText(textPosX, fPosY-(nLine*fLineDist), fFontSize,"+"..string.sub(implement3.object.name,0, NameSizeLimit));
								textPosX=textPosX+getTextWidth(fFontSize,tostring("+"..string.sub(implement3.object.name,0, NameSizeLimit)));
								if vehicle.isHired then	setTextColor(0.72,0.80,0.98,1);	end;
								if (FillType == "fertilizer" or FillType == "seeds") and FillPercentage < 10 then setTextBold(true);setTextColor(1,0,0,1); end;
								renderText(textPosX, fPosY-(nLine*fLineDist), fFontSize,"@");
								textPosX=textPosX+getTextWidth(fFontSize,"@");	
								if implement2.object.fillLevel > 0 then
									if dShowPercent then
										renderText(textPosX, fPosY-(nLine*fLineDist), fFontSize,tostring(math.ceil(FillPercentage - 0.5)).."%");
										textPosX=textPosX+getTextWidth(fFontSize,tostring(math.ceil(FillPercentage - 0.5)).."%");
									end;
									if dShowPercent and dShowFill then 
										renderText(textPosX, fPosY-(nLine*fLineDist), fFontSize,"=");
										textPosX=textPosX+getTextWidth(fFontSize,"=");
									end							
									if dShowFill then
										renderText(textPosX, fPosY-(nLine*fLineDist), fFontSize,tostring(math.ceil(implement3.object.fillLevel)).."L");
										textPosX=textPosX+getTextWidth(fFontSize,tostring(math.ceil(implement3.object.fillLevel)).."L");
									end;							
									renderText(textPosX, fPosY-(nLine*fLineDist),fFontSize," ("..i18FillType..")");
									textPosX=textPosX+getTextWidth(fFontSize,tostring(" ("..i18FillType..")"));
									setTextColor(1,1,1,1);setTextBold(false);
								else
									renderText(textPosX, fPosY-(nLine*fLineDist), fFontSize," (Empty)");
									textPosX=textPosX+getTextWidth(fFontSize,tostring(" (Empty)"));							
								end;
								end;
						end;
							for Index3,implement4 in pairs(implement3.object.attachedImplements) do
								if implement4.object.fillLevel ~= nil and implement4.object.capacity ~= nil and implement4.object.currentFillType ~= nil and implement4.object.name ~= nil then
									if implement4.object.fillLevel ~= nil and implement4.object.capacity ~= nil then
										FillPercentage = implement4.object.fillLevel / implement4.object.capacity * 100;
										local FillType = "";
										if implement4.object.currentFillType ~= Fillable.FILLTYPE_UNKNOWN then
											FillType = Fillable.fillTypeIntToName[implement4.object.currentFillType];
										else 
											FillType = "unknown";											
										end;
										i18FillType = "";
										if g_i18n:hasText(FillType) then
											i18FillType = g_i18n:getText(FillType);
										else 
											i18FillType = FillType;	-- if not translate version
										end;
										if Printed ~= true then 
											if vehicle.isHired then	setTextColor(0.72,0.80,0.98,1);	end;
											renderText(textPosX, fPosY-(nLine*fLineDist), fFontSize, i..") "..textController..textVehicleName); -- print controler + vehicle name
											Printed = true;
											textPosX=textPosX+getTextWidth(fFontSize,tostring(i..") "..textController));
											textPosX=textPosX+getTextWidth(fFontSize,tostring(textVehicleName));
											setTextColor(1,1,1,1);
											hasFillable = true;	
										end;
										if textPosX+getTextWidth(fFontSize,tostring("xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx")) > LineWrap then
											nLine = nLine + 1;
											textPosX = fPosX + getTextWidth(fFontSize,tostring(i..") "..textController..textVehicleName));
										end;
										renderText(textPosX, fPosY-(nLine*fLineDist), fFontSize,"+"..string.sub(implement4.object.name,0, NameSizeLimit));
										textPosX=textPosX+getTextWidth(fFontSize,tostring("+"..string.sub(implement4.object.name,0, NameSizeLimit)));
										if vehicle.isHired then	setTextColor(0.72,0.80,0.98,1);	end;
										if (FillType == "fertilizer" or FillType == "seeds") and FillPercentage < 10 then setTextBold(true);setTextColor(1,0,0,1); end;
										renderText(textPosX, fPosY-(nLine*fLineDist), fFontSize,"@");
										textPosX=textPosX+getTextWidth(fFontSize,"@");	
										if implement2.object.fillLevel > 0 then
											if dShowPercent then
												renderText(textPosX, fPosY-(nLine*fLineDist), fFontSize,tostring(math.ceil(FillPercentage - 0.5)).."%");
												textPosX=textPosX+getTextWidth(fFontSize,tostring(math.ceil(FillPercentage - 0.5)).."%");
											end;
											if dShowPercent and dShowFill then 
												renderText(textPosX, fPosY-(nLine*fLineDist), fFontSize,"=");
												textPosX=textPosX+getTextWidth(fFontSize,"=");
											end							
											if dShowFill then
												renderText(textPosX, fPosY-(nLine*fLineDist), fFontSize,tostring(math.ceil(implement4.object.fillLevel)).."L");
												textPosX=textPosX+getTextWidth(fFontSize,tostring(math.ceil(implement4.object.fillLevel)).."L");
											end;							
											renderText(textPosX, fPosY-(nLine*fLineDist),fFontSize," ("..i18FillType..")");
											textPosX=textPosX+getTextWidth(fFontSize,tostring(" ("..i18FillType..")"));
											setTextColor(1,1,1,1);setTextBold(false);
										else
											renderText(textPosX, fPosY-(nLine*fLineDist), fFontSize," (Empty)");
											textPosX=textPosX+getTextWidth(fFontSize,tostring(" (Empty)"));							
										end;
									end;
								end;
							end;
						end;
					end;
				end;					
				if Printed  then 
					local fuelPercentage = (vehicle.fuelFillLevel / vehicle.fuelCapacity +0.0001) * 100;
					if fuelPercentage > 100 then 
						fuelPercentage = 100;
					end;
					fuelPercentage= math.floor(fuelPercentage);
					if vehicle.isHired and fuelPercentage <= 10 then												-- change color if fuel is low
						setTextBold(true);
						setTextColor(1,0,0,1);
						renderText(textPosX, fPosY-(nLine*fLineDist), fFontSize," Fuel: "..fuelPercentage.."%");			-- print fuel %
						textPosX=textPosX+getTextWidth(fFontSize,tostring(" Fuel: "..fuelPercentage.." %"));
						setTextBold(false);
						setTextColor(1,1,1,1);
					else
						setTextColor(1, 1, 0,0.5);
						renderText(textPosX, fPosY-(nLine*fLineDist), fFontSize," Fuel: "..fuelPercentage.."%");			-- print fuel %
						textPosX=textPosX+getTextWidth(fFontSize,tostring(" Fuel: "..fuelPercentage.." %"));
					end;
					local lastSpeed = vehicle.lastSpeed*3600;
					if lastSpeed > 2 and lastSpeed ~= nil then
						setTextColor(0, 0.2, .5,1);
						if lastSpeed < 10 then
							renderText(textPosX, fPosY-(nLine*fLineDist), fFontSize,"Speed:".." "..math.ceil(lastSpeed).."km/h");
						else
							renderText(textPosX, fPosY-(nLine*fLineDist), fFontSize,"Speed:"..math.ceil(lastSpeed).."km/h");
						end;
						textPosX=textPosX+getTextWidth(fFontSize,tostring("Speed:"..math.ceil(lastSpeed).."km/h"));
					else
						setTextColor(0.98,0.76,0.43,0.9);
						renderText(textPosX, fPosY-(nLine*fLineDist), fFontSize," <Stopped>");
						textPosX=textPosX+getTextWidth(fFontSize,tostring(" <Stopped>"));
						setTextColor(0.72,0.80,0.98,1);		
					end;	
				end;
				if Printed then
					nLine = nLine + 1;
					TextPosX = fPosX;
				end;
				Printed = false;
		end;
	end;
end;

addModEventListener(Loadstatus);
